// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _XCAFDoc_DocumentTool_HeaderFile
#define _XCAFDoc_DocumentTool_HeaderFile

#include <Standard.hxx>
#include <Standard_DefineHandle.hxx>
#include <Handle_XCAFDoc_DocumentTool.hxx>

#include <TDF_Attribute.hxx>
#include <Standard_Boolean.hxx>
#include <Handle_TDocStd_Document.hxx>
#include <Handle_XCAFDoc_ShapeTool.hxx>
#include <Handle_XCAFDoc_ColorTool.hxx>
#include <Handle_XCAFDoc_LayerTool.hxx>
#include <Handle_XCAFDoc_DimTolTool.hxx>
#include <Handle_XCAFDoc_MaterialTool.hxx>
#include <Handle_TDF_Attribute.hxx>
#include <Handle_TDF_RelocationTable.hxx>
class Standard_GUID;
class TDF_Label;
class TDocStd_Document;
class XCAFDoc_ShapeTool;
class XCAFDoc_ColorTool;
class XCAFDoc_LayerTool;
class XCAFDoc_DimTolTool;
class XCAFDoc_MaterialTool;
class TDF_Attribute;
class TDF_RelocationTable;


//! Defines sections structure of an XDE document.
//! attribute marking CAF document as being DECAF document.
//! Creates the sections structure of the document.
class XCAFDoc_DocumentTool : public TDF_Attribute
{

public:

  
  Standard_EXPORT static  const  Standard_GUID& GetID() ;
  
  //! Create (if not exist) DocumentTool attribute
  //! on 0.1 label if <IsAcces> is true, else
  //! on <L> label.
  //! This label will be returned by DocLabel();
  //! If the attribute is already set it won't be reset on
  //! <L> even if <IsAcces> is false.
  //! ColorTool and ShapeTool attributes are also set by this method.
  Standard_EXPORT static   Handle(XCAFDoc_DocumentTool) Set (const TDF_Label& L, const Standard_Boolean IsAcces = Standard_True) ;
  
  Standard_EXPORT static   Standard_Boolean IsXCAFDocument (const Handle(TDocStd_Document)& Doc) ;
  
  //! Returns label where the DocumentTool attribute is or
  //! 0.1 if DocumentTool is not yet set.
  Standard_EXPORT static   TDF_Label DocLabel (const TDF_Label& acces) ;
  
  //! Returns sub-label of DocLabel() with tag 1.
  Standard_EXPORT static   TDF_Label ShapesLabel (const TDF_Label& acces) ;
  
  //! Returns sub-label of DocLabel() with tag 2.
  Standard_EXPORT static   TDF_Label ColorsLabel (const TDF_Label& acces) ;
  
  //! Returns sub-label of DocLabel() with tag 3.
  Standard_EXPORT static   TDF_Label LayersLabel (const TDF_Label& acces) ;
  
  //! Returns sub-label of DocLabel() with tag 4.
  Standard_EXPORT static   TDF_Label DGTsLabel (const TDF_Label& acces) ;
  
  //! Returns sub-label of DocLabel() with tag 5.
  Standard_EXPORT static   TDF_Label MaterialsLabel (const TDF_Label& acces) ;
  
  //! Creates (if it does not exist) ShapeTool attribute on ShapesLabel().
  Standard_EXPORT static   Handle(XCAFDoc_ShapeTool) ShapeTool (const TDF_Label& acces) ;
  
  //! Creates (if it does not exist) ColorTool attribute on ColorsLabel().
  Standard_EXPORT static   Handle(XCAFDoc_ColorTool) ColorTool (const TDF_Label& acces) ;
  
  //! Creates (if it does not exist) LayerTool attribute on LayersLabel().
  Standard_EXPORT static   Handle(XCAFDoc_LayerTool) LayerTool (const TDF_Label& acces) ;
  
  //! Creates (if it does not exist) DimTolTool attribute on DGTsLabel().
  Standard_EXPORT static   Handle(XCAFDoc_DimTolTool) DimTolTool (const TDF_Label& acces) ;
  
  //! Creates (if it does not exist) DimTolTool attribute on DGTsLabel().
  Standard_EXPORT static   Handle(XCAFDoc_MaterialTool) MaterialTool (const TDF_Label& acces) ;
  
  Standard_EXPORT XCAFDoc_DocumentTool();
  
  //! to be called when reading this attribute from file
  Standard_EXPORT   void Init()  const;
  
  Standard_EXPORT  const  Standard_GUID& ID()  const;
  
  Standard_EXPORT   void Restore (const Handle(TDF_Attribute)& with) ;
  
  Standard_EXPORT   Handle(TDF_Attribute) NewEmpty()  const;
  
  Standard_EXPORT   void Paste (const Handle(TDF_Attribute)& into, const Handle(TDF_RelocationTable)& RT)  const;
  
  //! Unregisters the document holding this attribute from an
  //! internal global map of XDE documents.
  Standard_EXPORT virtual   void Destroy() ;
~XCAFDoc_DocumentTool()
{
  Destroy();
}



  DEFINE_STANDARD_RTTI(XCAFDoc_DocumentTool)

protected:




private: 




};







#endif // _XCAFDoc_DocumentTool_HeaderFile
